#include "Addons.h"
//****************************************
// Addons
//****************************************

// You can NOT modify this function!!
Addons::Addons( image_id id )
{
	mId	= id;
}

// ここで、Addons Menuに追加するメニューを設定してください。
// 	
void 
Addons::Init( BMenu* menu)		//set up
{
	Addons*		pAddons = this;
	BMenuItem	*mpItem;
	// Addons MenuのサブメニューとしてHTML Menuを追加する
	BMenu *subMenu = new BMenu("HTML");
	
	// HTML MenuにMenu Itemを追加する。
	// indexは、何番目のMenuかを表しています。
	
	/// Add HTML base Menu	
	BMessage* addons_msg = new BMessage( Addons_MSG );
	addons_msg->AddPointer( "Addonsptr", pAddons );
	addons_msg->AddInt16("index",0);  
	mpItem = new BMenuItem(	"HTML BASE", addons_msg );
	subMenu->AddItem(mpItem);
	
	/// Add <img src> Menu	
	addons_msg = new BMessage(Addons_MSG);
	addons_msg->AddPointer( "Addonsptr", this );
	addons_msg->AddInt16("index",1);
	mpItem = new BMenuItem(	"<IMG SRC>", addons_msg );
	subMenu->AddItem(mpItem);

	/// Add <A HREF> Menu	
	addons_msg = new BMessage( Addons_MSG );
	addons_msg->AddPointer( "Addonsptr", this );
	addons_msg->AddInt16("index",2);
	mpItem = new BMenuItem(	"<A HREF>", addons_msg );
	subMenu->AddItem(mpItem);
	
    /// Add Table base Menu	
	addons_msg = new BMessage( Addons_MSG );
	addons_msg->AddPointer( "Addonsptr", this );
	addons_msg->AddInt16("index",3);
	mpItem = new BMenuItem(	"TABLE BASE", addons_msg );
	subMenu->AddItem(mpItem);
	
	/// Add <BR> Menu	
	addons_msg = new BMessage( Addons_MSG );
	addons_msg->AddPointer( "Addonsptr", this );
	addons_msg->AddInt16("index",4);
	mpItem = new BMenuItem(	"<BR>", addons_msg ,'B',B_COMMAND_KEY | B_SHIFT_KEY);
	subMenu->AddItem(mpItem);
	
	
	/// Add <P> Menu	
	addons_msg = new BMessage( Addons_MSG );
	addons_msg->AddPointer( "Addonsptr", this );
	addons_msg->AddInt16("index",5);
	mpItem = new BMenuItem(	"<P>", addons_msg ,'P',B_COMMAND_KEY | B_SHIFT_KEY);
	subMenu->AddItem(mpItem);

	/// Add <CENTER> Menu	
	addons_msg = new BMessage( Addons_MSG );
	addons_msg->AddPointer( "Addonsptr", this );
	addons_msg->AddInt16("index",6);
	mpItem = new BMenuItem(	"<CENTER>", addons_msg ,'C',B_COMMAND_KEY | B_SHIFT_KEY);
	subMenu->AddItem(mpItem);
	
	/// Add <BLOCKQUOTE> Menu	
	addons_msg = new BMessage( Addons_MSG );
	addons_msg->AddPointer( "Addonsptr", this );
	addons_msg->AddInt16("index",7);
	mpItem = new BMenuItem(	"<BLOCKQUOTE>", addons_msg);
	subMenu->AddItem(mpItem);
	
	/// Add <OL> Menu	
	addons_msg = new BMessage( Addons_MSG );
	addons_msg->AddPointer( "Addonsptr", this );
	addons_msg->AddInt16("index",8);
	mpItem = new BMenuItem(	"<OL>", addons_msg);
	subMenu->AddItem(mpItem);
	
	/// Add <LI> Menu	
	addons_msg = new BMessage( Addons_MSG );
	addons_msg->AddPointer( "Addonsptr", this );
	addons_msg->AddInt16("index",9);
	mpItem = new BMenuItem(	"<LI>", addons_msg ,'I',B_COMMAND_KEY | B_SHIFT_KEY);
	subMenu->AddItem(mpItem);
	
	/// Add <LI> Menu	
	addons_msg = new BMessage( Addons_MSG );
	addons_msg->AddPointer( "Addonsptr", this );
	addons_msg->AddInt16("index",10);
	mpItem = new BMenuItem(	"<FONT>", addons_msg);
	subMenu->AddItem(mpItem);
	
	/// Add SubMenu
	menu->AddItem( subMenu );

}

//********************************************************
//    inView : HotEditのTextViewです。
//    index  : 選択されたMenuが何番目のMenuかを表しています。
//  この関数が"false"を返すと、Text Fileが改変されたことになります。
//  "true"を返すと、Text Fileが改変されていないことになります。
//********************************************************
bool
Addons::Effect(BTextView *inView,int16 index)
{
	// Get Selectoin start and end point
	int32 start,end;
	inView->GetSelection(&start,&end);	
	
	char* text;     // Selection Text
	char* dest;     // Insertion Text 
	text = new char[end-start+2 ];
	dest = new char[1024];
	::memset(dest,0,1024);
	// Get Selection Text
	inView->GetText(start,end-start,text);
	switch(index)
	{
	case 0:
	{
		strcpy(dest,"<html>\n");
		strcat(dest,"<head>\n");
		strcat(dest,"<meta name=\"generator\" content=\"HotEdit for BeOS\">\n"); 
		strcat(dest,"<title>TITLE");
		//strcat(dest,text);
		strcat(dest,"</title>\n");
		strcat(dest,"</head>\n");
		strcat(dest,"<body bgcolor=\"FFFFFF\">\n\n");
		//strcat(dest,text);
		strcat(dest,"</body>\n");
		strcat(dest,"</html>");
		SendInsert(inView,dest,start,strlen(dest));
		break;
	}
		
	case 1:
	{
		strcpy(dest,"<img src=\"filename\" ALT=\"any text\">");
		SendInsert(inView,dest,start,strlen(dest));
		break;
	}
	case 2:
	{
		strcpy(dest,"<a href=\"filename\">");
		strcat(dest,text);
		strcat(dest,"</A>");
		SendInsert(inView,dest,start,strlen(dest));
		break;
	}
		
	case 3:
	{
		strcpy(dest,"<table border=5>\n");
		strcat(dest,"<th>COLUMN1</th>   <th>COLUMN2</th>\n");
		strcat(dest,"<tr>\n");
		strcat(dest,"<td>1</td> <td>2</td>\n");
		strcat(dest,"<tr>\n");
		strcat(dest,"<td>3</td> <td>4</td>\n");
		strcat(dest,"</table>\n");
		SendInsert(inView,dest,start,strlen(dest));
		break;
	}
			
		
	case 4:
	{
		strcpy(dest,"<br>");
		SendInsert(inView,dest,start,strlen(dest));
		break;
	}
		
	case 5:
	{
		strcpy(dest,"<p>");
		SendInsert(inView,dest,start,strlen(dest));
		break;
	}
	
	case 6:
	{
		strcpy(dest,"<center>");
		strcat(dest,text);
		strcat(dest,"</center>");
		SendInsert(inView,dest,start,strlen(dest));
		break;
	}
	
	case 7:
	{	
		strcpy(dest,"<blockquote>");
		strcat(dest,text);
		strcat(dest,"</blockquote>");
		SendInsert(inView,dest,start,strlen(dest));
		break;
	}
	
	case 8:
	{
		strcpy(dest,"<ol>\n");
		strcat(dest,"<li>LIST 1\n");
		strcat(dest,"</ol>\n");
		SendInsert(inView,dest,start,strlen(dest));
		break;
	}
	
	case 9:
	{
		strcpy(dest,"<li>");
		SendInsert(inView,dest,start,strlen(dest));
		break;
	}
	
	case 10:
	{
		strcpy(dest,"<font color=\"#000000\" size=+0>");
		strcat(dest,text);
		strcat(dest,"</font>");
		SendInsert(inView,dest,start,strlen(dest));
		break;
	}
	
	default:
		break;
	}
	delete[] dest;
	delete[] text;
	return true;
}

/***********************************************************
 * Send insert message
 ***********************************************************/
void
Addons::SendInsert(BTextView *view,
					const char* text,
					int32 offset,
					int32 length)
{
	BMessage msg(H_ADDONS_INSERT);
	msg.AddString("text",text);
	msg.AddInt32("offset",offset);
	msg.AddInt32("length",length);
	
	view->Window()->PostMessage(&msg,view);
}

/***********************************************************
 * Send delete message
 ***********************************************************/
void		
Addons::SendDelete(BTextView *view,
					int32 offset,
					int32 length)
{
	BMessage msg(H_ADDONS_DELETE);
	msg.AddInt32("offset",offset);
	msg.AddInt32("length",length);
	
	view->Window()->PostMessage(&msg,view);
}

/***********************************************************
 * Send select message
 ***********************************************************/
void
Addons::SendSelect(BTextView *view,
					int32 offset,
					int32 length)
{
	BMessage msg(H_ADDONS_SELECT);
	msg.AddInt32("offset",offset);
	msg.AddInt32("length",length);
	
	view->Window()->PostMessage(&msg,view);

}